From efc7e88afda3e4581016cedb3128206d19d9d01b Mon Sep 17 00:00:00 2001
From: Johnson Chu <johnsoncodehk@gmail.com>
Date: Fri, 7 Mar 2025 02:55:34 +0800
Subject: [PATCH 10/13] fix(typescript): focus update target file version on
 association dirty (#267)

---
 packages/language-core/index.ts                       |  4 +++-
 .../lib/quickstart/languageServicePluginCommon.ts     | 11 +++++++++++
 2 files changed, 14 insertions(+), 1 deletion(-)

diff --git a/packages/language-core/index.ts b/packages/language-core/index.ts
index 853feac7..cefcd2e7 100644
--- a/packages/language-core/index.ts
+++ b/packages/language-core/index.ts
@@ -22,7 +22,8 @@ export const defaultMapperFactory: MapperFactory = mappings => new SourceMap(map
 export function createLanguage<T>(
 	plugins: LanguagePlugin<T>[],
 	scriptRegistry: Map<T, SourceScript<T>>,
-	sync: (id: T, includeFsFiles: boolean, shouldRegister: boolean) => void
+	sync: (id: T, includeFsFiles: boolean, shouldRegister: boolean) => void,
+	onAssociationDirty?: (targetId: T) => void
 ) {
 	const virtualCodeToSourceScriptMap = new WeakMap<VirtualCode, SourceScript<T>>();
 	const virtualCodeToSourceMap = new WeakMap<IScriptSnapshot, WeakMap<IScriptSnapshot, Mapper>>();
@@ -213,6 +214,7 @@ export function createLanguage<T>(
 			const sourceScript = scriptRegistry.get(id);
 			if (sourceScript) {
 				sourceScript.isAssociationDirty = true;
+				onAssociationDirty?.(sourceScript.id);
 			}
 		});
 	}
diff --git a/packages/typescript/lib/quickstart/languageServicePluginCommon.ts b/packages/typescript/lib/quickstart/languageServicePluginCommon.ts
index 002c7518..2b65055c 100644
--- a/packages/typescript/lib/quickstart/languageServicePluginCommon.ts
+++ b/packages/typescript/lib/quickstart/languageServicePluginCommon.ts
@@ -60,6 +60,17 @@ export function createLanguageCommon(
 			else {
 				language.scripts.delete(fileName);
 			}
+		},
+		targetFileName => {
+			// https://github.com/JetBrains/intellij-plugins/blob/6435723ad88fa296b41144162ebe3b8513f4949b/Angular/src-js/angular-service/src/ngCommands.ts#L88
+			(info.session as any).change({
+				file: targetFileName,
+				line: 1,
+				offset: 1,
+				endLine: 1,
+				endOffset: 1,
+				insertString: '',
+			});
 		}
 	);
 

